/* ------------------------------------------- */
/* Memory Lib For C                            */
/*        Version 1.00                         */
/*         2000/10/10/0                        */
/*        (c)Copyright 2000 Ituki Kirihara/NI  */
/*                       All rights reserved.  */
/* ------------------------------------------- */
#if 0
/*
    gpɓ
      Ituki Kirihara/NI͂̊֐QgɂĐ؂̐ӔC𕉂܂B
      e̐ӔCŎgpĉB
      Ŏg͈͓łłΕύXĉČ\łB
      ̊֐Q̃vO̍Ĕzz͋֎~܂B
      l͈͓̔ŎgĉBiꕔύXꍇlƂĂ܂j
      ̊֐Q𗘗păvO쐬AȊOɌJꍇA[U[
      ̊֐Q𗘗pƂ𕪂悤ɂĒuĉB
      ܂Å֐Q̃\[X(http://members.filworks.com/ituki/)𖾋LĒuĉB
      ̏𖞂ARpCς݂̃vO͎RɔzzĉČ\łB
*/
#endif

#include "Memlib.h"

/* !! TOP NODE IS NOT USED !! */

#define NotNULL ((void*)1)

/* Memory Allocation Function */
/* ReleaseMemory */
/* if error, return NULL else not NULL. */
void* _Memlib_Free(Memlib_MEM* mem,void* pointer)
{
  Memlib_MEM* memdat;
  if(pointer == NULL) return NotNULL;
  if(mem == NULL) return NULL;
  if(mem->lp != NULL || mem->len != 0) return NULL;
  if(mem->next == NULL) return NULL;
  /* search this data. */
  do{
    if(mem->next->lp == pointer){
      /* next node is match. */
      /* next.next node backup */
      memdat = mem->next->next;
      /* next node delete. */
      free(pointer);
      free(mem->next);
      mem->next = memdat;
      return NotNULL;
    }
    mem = mem->next;
  }while(mem->next != NULL);
  return NULL;
}
/* All Delete. */
void* _Memlib_AllFree(Memlib_MEM* mem)
{
  Memlib_MEM* memdat;
  if(mem == NULL) return NULL;
  if(mem->lp != NULL || mem->len != 0) return NULL;
  if(mem->next == NULL) return NotNULL;
  memdat = mem;
  mem = mem->next;
  memdat->next = NULL;
  while(mem != NULL){
    /* Next Backup */
    memdat = mem->next;
    if(mem->lp != NULL){
      /* free this data */
      free(mem->lp);
    }
    /* free this node */
    free(mem);
    /* next. */
    mem = memdat;
  }
  return NotNULL;
}
/* AllocMemory */
/* if error, return NULL else Address.. */
void* _Memlib_Alloc(Memlib_MEM* mem,Memlib_INT32 size)
{
  if(mem == NULL) return NULL;
  if(size < 1 || size > Memlib_MEM_MAX) return NULL;
  /* search last node. */
  while(mem->next != NULL) mem = mem->next;
  /* mem is last node. */
  /* create new node */
  mem->next = (Memlib_MEM*)calloc(1,sizeof(Memlib_MEM));
  if(mem->next == NULL) return NULL; /* ERROR */
  mem->next->lp = calloc(1,size);
  if(mem->next->lp == NULL){
    /* delete node */
    free(mem->next);
    mem->next = NULL;
    return NULL;
  }
  mem->next->len = size;
  mem->next->next = NULL;
  return mem->next->lp;
}


/* Default MEM */
static Memlib_MEM Memlib_Default={NULL,0,NULL};

/* DefaultMemoryAllocation */
/* if error, return NULL else not NULL. */
void* Memlib_Free(void* Pointer)
{
  return _Memlib_Free(&Memlib_Default,Pointer);
}
/* All Delete. */
void* Memlib_AllFree(void)
{
  return _Memlib_AllFree(&Memlib_Default);
}
/* AllocMemory */
/* if error, return NULL else Address.. */
void* Memlib_Alloc(Memlib_INT32 size)
{
  return _Memlib_Alloc(&Memlib_Default,size);
}


